module mem_addr_gen(
  input clk,
  input rst,
  input en,
  input [9:0] h_cnt,
  input [9:0] v_cnt,
  output [16:0] pixel_addr
);
    
reg [7:0] position;
reg [7:0] next_position;
  
assign pixel_addr = ((h_cnt>>1)+320*(v_cnt>>1)+ position*320 )% 76800;  //640*480 --> 320*240 

  always @*
    if (rst)
      next_position = 0;
    else if (position < 239 && en == 1'b1)
      next_position = position + 1;
    else if (position < 239 && en == 1'b0)
      next_position = position;
    else
      next_position = 0;
    
  always @(posedge clk or posedge rst)  
    if (rst)
      position <= 8'd0;
    else
      position <= next_position;
endmodule
